<?php
/***************************** Version 20220314 ***************************/
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) {
//--self downloader --
   $filenameReal = __FILE__;
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header('Connection: close');
   readfile($filenameReal);
   exit;
}?>
<div id="selectors">
<div>
<?php
ini_set("allow_url_fopen", true);
/************************ Set Test Parameters for Debugging Purposes ********************/
	if (!isset($sector)) { // For debugging set some defaults if 'inc-wxussectors-hanis3.php' is called alone
//		$_SESSION["CSSwidescreen"]=false; // Establish wideScreen for Testing
		echo '<script src="//ajax.googleapis.com/ajax/libs/jquery/1.11.3/jquery.min.js" type="text/javascript"></script>';
		$standAlone = false; // Displays outside of Saratoga template
		$displayWide = true; // If true, display the wide GIF's
//		$imageWidth = ($standAlone?1200:600); // Default image width
		$satBand = 'CONUS'; // Default sector type is set here
		$sector = 'tpw'; // IMPORTAMT!!! Default sector location is set here
		$doDebug = true; // Enable/disable Debug output
		$debugText = ''; // Initialize
		$addTime = true; // Add Zulu time to images
		$useUTC = true; // Use UTC time rather than Zulu time (UTC adds seconds counter)
 		$divWidth = 660;  // Jim Wyman 3/18/2019 - This variable sets the maximum width of the iFrame that the images will be displayed in. This allows for scaling large images to correctly fit the iframe
		      // this will only adjust images whose original size is larger than the iframe. Smaller size will not be affected.
//		$wideScreen = false; // Test Saratoga wideScreen settings
	}
/************************ End Test Parameters for Debugging Purposes ********************/
  if (isset($_POST['standAlone'])) {
    $standAlone = $_POST['standAlone'];
  }
  if (isset($_POST['divWidth'])) {
    $divWidth = $_POST['divWidth'];
  }
  if (isset($_POST['displayWide'])) {
    $displayWide = $_POST['displayWide'];
  }
  if (isset($_POST['sector'])) {
    $sector = $_POST['sector'];
  }
  if (isset($_POST['satBand'])) {
    $satBand = $_POST['satBand'];
  }
  if (isset($_POST['imageWidth'])) {
    $imageWidth = $_POST['imageWidth'];
  }
  if (isset($_POST['imageHeight'])) {
    $imageHeight = $_POST['imageHeight'];
  }
  if (isset($_POST['doDebug'])) {
    $doDebug = $_POST['doDebug'];
  }
  if (isset($_POST['wideScreen'])) {
    $wideScreen = $_POST['wideScreen'];
  }
  if (isset($_POST['addTime'])) {
    $addTime = $_POST['addTime'];
  }
  if (isset($_POST['useUTC'])) {
    $useUTC = $_POST['useUTC'];
  }
	if ($doDebug) {
		$debugText = ''; // Initialize
	}
	if (!isset($wideScreen)) {
		if ($doDebug) $debugText .= '$wideScreen is not set!<br/>';
		$wideScreen = false;
	}

	if ($doDebug) {
		$debugText .= 'isset($_SESSION[CSSwidescreen]): '.((isset($_SESSION["CSSwidescreen"]))?'true':'false').'<br/>';
		$debugText .= '$wideScreen: '.((isset($_SESSION["CSSwidescreen"])&&$_SESSION["CSSwidescreen"]==true)?'true':'false').'<br/>';
		if (isset($wideScreen)) {
			$debugText .= (', $wideScreen0: '.($wideScreen?'true':'false')).'<br/>';
		}
	}


	if ($doDebug) $debugText .= ('$wideScreen1: '.($wideScreen?'true':'false')).'<br/>';
	$sectorTypes = array('standard','CONUS','wus-ak','tpw'); // Pointers to the various possible image dimensions
	if ($sector=='CONUS') $ourSectorType = $sectorTypes[1];
	else if ($sector=='wus'||$sector=='ak') $ourSectorType = $sectorTypes[2];
	else if ($sector=='tpw') $ourSectorType = $sectorTypes[3];
	else $ourSectorType = $sectorTypes[0];

	$sectorDimensions = array('width','height');
	$satBandSectors = array( // Array of arrays of possible image dimensions
		'standard'=>array( // The US Regional Image Dimensions
			'width'=>600,
			'height'=>600),
		'CONUS'=>array( // The Pacific US Image Dimensions
			'width'=>625,
			'height'=>375),
		'wus-ak'=>array( // Guam, Western US, Eastern Pacific, Central America, Mexico
			'width'=>1000,
			'height'=>1000),
		'tpw'=>array( // The Tropical Pacific Dimensions
			'width'=>900,
			'height'=>540)
		);

	$imageWidth = $satBandSectors[$ourSectorType]['width'];
	$imageHeight = $satBandSectors[$ourSectorType]['height'];
	/* Debug Code *
	if ($doDebug) {
		var_dump($satBandSectors);
		foreach ($satBandSectors as $key1=>$value1) {
		foreach ($value1 as $key=>$value)
			$debugText .= '$key1: '.$key1.'=> '.$key.': '.$value.'<br/>';
		}
		$debugText .= '$ourSectorType: '.$ourSectorType.'<br/>';
//		exit;
	}
	/* End Debug Code */
	/* Debug Code */
	if ($doDebug) {
		$debugText .= '$satBand: '.$satBand.', $sector: '.$sector.', $ourSectorType: '.$ourSectorType.'<br/>';
		$debugText .= '$imageWidth: '.$imageWidth.', $imageHeight: '.$imageHeight.'<br/>';
//		exit;
	}
/* End Debug Code */	

?>
    <table width="600px">
    <tr style="vertical-align:bottom">

		<?php $satBand = (($satBand!='GEOCOLOR'&&$satBand!='AirMass'&&$satBand!='FireTemperature'&&$satBand!='EXTENT3'&&$satBand!='CONUS')?($satBand<10?('0'.intval($satBand)):$satBand):$satBand); ?>    
    <td width="50%" align="center" style="padding:3px;">

    <span style="color:black; font-size:13px; font-family:arial, times new roman;">
    <b>Satellite Band</b> &nbsp;
    </span>
    <select style="background-color:darkslategray;border-radius:7px;color:white;" id="satBand">
    <option value="GEOCOLOR"<?php echo ($satBand=="GEOCOLOR"?' selected="selected"':'')?>>Geocolor</option>
	<option value="AirMass"<?php echo($satBand=="AirMass"?' selected="selected"':'')?>>AirMass</option>
	<option value="FireTemperature"<?php echo($satBand=="FireTemperature"?' selected="selected"':'')?>>FireTemperature</option>
	<option value="EXTENT3"<?php echo($satBand=="EXTENT3"?' selected="selected"':'')?>>Lightning</option>

<!--
    <option value="01"<?php echo ($satBand=="01"?' selected="selected"':'')?>>Blue Visible</option>
-->
    <option value="02"<?php echo ($satBand=="02"?' selected="selected"':'')?>>Red Visible</option>
<!--
    <option value="03"<?php echo ($satBand=="03"?' selected="selected"':'')?>>Veggie - Near IR</option>
    <option value="04"<?php echo ($satBand=="04"?' selected="selected"':'')?>>Cirrus - Near IR</option> 
    <option value="05"<?php echo ($satBand=="05"?' selected="selected"':'')?>>Snow/Ice - Near IR</option>
    <option value="06"<?php echo ($satBand=="06"?' selected="selected"':'')?>>Cloud Particle - Near IR</option>
-->
    <option value="07"<?php echo ($satBand=="07"?' selected="selected"':'')?>>Shortwave Window - IR</option>
    <option value="08"<?php echo ($satBand=="08"?' selected="selected"':'')?>>Upper-Level Water Vapor - IR</option>
<!--
    <option value="09"<?php echo ($satBand=="09"?' selected="selected"':'')?>>Mid-Level Water Vapor - IR</option>
    <option value="10"<?php echo ($satBand=="10"?' selected="selected"':'')?>>Lower-Level Water Vapor - IR</option>
    <option value="11"<?php echo ($satBand=="11"?' selected="selected"':'')?>>Cloud Top - IR</option>
    <option value="12"<?php echo ($satBand=="12"?' selected="selected"':'')?>>Ozone - IR</option>
-->    <option value="13"<?php echo ($satBand=="13"?' selected="selected"':'')?>>Clean Longwave Window - IR</option>
<!--    <option value="14"<?php echo ($satBand=="14"?' selected="selected"':'')?>>Longwave Window - IR</option>
    <option value="15"<?php echo ($satBand=="15"?' selected="selected"':'')?>>Dirty Longwave Window - IR</option>
-->
    <option value="16"<?php echo ($satBand=="16"?' selected="selected"':'')?>>CO2 Longwave Window - IR</option>
		</select>
	</td>

	<td width="50%" align="center" style="padding:3px;">
<?php /*
		"CONUS" is the Pacific West
		"wus" is US West Coast
		"ak" is Alaska
		"tpw" is the Tropical Pacific
		"hi" is Hawaii
		"pnw" is the Pacific Northwest
		"psw" is the Pacific Southwest
*/?>    
    <span style="color:#000000; font-size:13px; font-family:arial, times new roman;">
    <b>Satellite View</b> &nbsp;
    </span>
    <select style="background-color:darkslategray;border-radius:7px;color:white;" id="sector">
    <option value="CONUS"<?php echo ($sector=="CONUS"?' selected="selected"':'')?>>Pacific West</option>
    <option value="wus"<?php echo ($sector=="wus"?' selected="selected"':'')?>>US West Coast</option>
    <option value="pnw"<?php echo ($sector=="pnw"?' selected="selected"':'')?>>Pacific Northwest</option>
    <option value="psw"<?php echo ($sector=="psw"?' selected="selected"':'')?>>Pacific Southwest</option>
    <option value="ak"<?php echo ($sector=="ak"?' selected="selected"':'')?>>Alaska</option>
    <option value="hi"<?php echo ($sector=="hi"?' selected="selected"':'')?>>Hawaii</option>
    <option value="tpw"<?php echo ($sector=="tpw"?' selected="selected"':'')?>>Tropical Pacific</option>
    </select>
	</td></tr></table>
  
  <?php 
	$satBand = (($satBand!='GEOCOLOR'&&$satBand!='AirMass'&&$satBand!='FireTemperature'&&$satBand!='EXTENT3'&&$satBand!='CONUS')?($satBand<10?('0'.intval($satBand)):$satBand):$satBand);    

	if ($sector=='CONUS') $ourSectorType = $sectorTypes[1];
	else if ($sector=='wus'||$sector=='ak') $ourSectorType = $sectorTypes[2];
	else if ($sector=='tpw') $ourSectorType = $sectorTypes[3];
	else $ourSectorType = $sectorTypes[0];

	$gifWidth = $satBandSectors[$ourSectorType]['width'];
	$imageWidth = $satBandSectors[$ourSectorType]['width'];
	$imageHeight = $satBandSectors[$ourSectorType]['height'];

	if ($satBand=='EXTENT3') $nesdisDirectory = 'GLM';
	else $nesdisDirectory = 'ABI';

			/* Debug Code */
	if ($doDebug) {
		$debugText .= '$satBand4: '.$satBand.', $sector: '.$sector.', $ourSectorType: '.$ourSectorType.'<br/>';
		$debugText .= '$imageWidth: '.$imageWidth.', $imageHeight: '.$imageHeight.'<br/>';
	}
/* End Debug Code */	
	/* Debug Code *
	if ($doDebug) {
		var_dump($satBandSectors);
		foreach ($satBandSectors as $key1=>$value1) {
		foreach ($value1 as $key=>$value)
			$debugText .= '$key1: '.$key1.'=> '.$key.': '.$value.'<br/>';
		}
		$debugText .= '$ourSectorType: '.$ourSectorType.'<br/>';
//		exit;
	}
	/* End Debug Code */
	/* Debug Code */
	if ($doDebug) {
		$debugText .= '$imageWidth: '.$imageWidth.', $imageHeight: '.$imageHeight.'<br/>';
		$debugText .= 'https://cdn.star.nesdis.noaa.gov/GOES17/'.$nesdisDirectory.'/SECTOR/'.$sector.'/'.$satBand.'/GOES17-'.strtoupper($sector).'-'.$satBand.'-'.$imageWidth.'x'.$imageHeight.'.gif<br/>';
//		exit;
	}
	/* End Debug Code */	
	$jsConstants = array(
			'var imageWidth = "'.$imageWidth.'";',
			'var imageHeight = "'.$imageHeight.'";',
			'var divWidth = "'.$divWidth.'";',
			'var doDebug = "'.($doDebug?'1':'0').'";'.
			'var standAlone = "'.($standAlone?'1':'0').'";'.
			'var displayWide = "'.($displayWide?'1':'0').'";'.
			'var wideScreen = "'.($wideScreen?'1':'0').'";',
			'var addTime = "'.($addTime?'1':'0').'";',
			'var useUTC = "'.$useUTC.'";'
	);
	?>

	
<script type="text/javascript">
		var $jq = jQuery.noConflict();
    $jq("#sector").change(function () {
	
			<?php for ($i=0; $i<count($jsConstants); $i++) {
				echo $jsConstants[$i];
			}?>
			var satBand = $jq("#satBand").val();
      var sector = $jq(this).val();
      showSatellite(standAlone,displayWide,sector,satBand,divWidth,imageWidth,imageHeight,doDebug,wideScreen,addTime,useUTC);
		});

    $jq("#satBand").change(function () {
			<?php for ($i=0; $i<count($jsConstants); $i++) {
				echo $jsConstants[$i];
			}?>
			var sector = $jq("#sector").val();
      var satBand = $jq(this).val();
      showSatellite(standAlone,displayWide,sector,satBand,divWidth,imageWidth,imageHeight,doDebug,wideScreen,addTime,useUTC);
		});
</script>
</div>
<?php $ratio = $divWidth/$imageWidth; // Jim Wyman 3/18/2019 - This variable calculates the ratio between the iframe width and the imagewidth being shown. It is used to scale both the width and height of the GIF to correctly scale both axes.
?>

<div class="center" align="center" style="width:<?php echo (($imageWidth>625&&(((!$standAlone&&!$wideScreen)||!$displayWide)))?$imageWidth*$ratio:$imageWidth)?>px"> <!-- <div> to align loop in center of display -->
<?php 
	if ($satBand=='EXTENT3') $nesdisDirectory = 'GLM';
	else $nesdisDirectory = 'ABI';
	if ($doDebug) {
		echo '$nesdisDirectory: '.$nesdisDirectory.'<br/>';
		echo 'https://cdn.star.nesdis.noaa.gov/GOES17/'.$nesdisDirectory.($sector=='CONUS'?'/':'/SECTOR/').$sector.'/'.$satBand.'/GOES17-'.strtoupper($sector).'-'.$satBand.'-'.$imageWidth.'x'.$imageHeight.'.gif';
	}
	$satBandSectors = array( // Array of arrays of possible image dimensions
		'standard'=>array( // The US Regional Image Dimensions
			'width'=>600,
			'height'=>600),
		'CONUS'=>array( // The Continental US Image Dimensions
			'width'=>625,
			'height'=>375),
		'wus-ak'=>array( // Guam, Western US, Eastern Pacific, Central America, Mexico
			'width'=>1000,
			'height'=>1000),
		'tpw'=>array( // The Tropical Pacific Dimensions
			'width'=>900,
			'height'=>540)
		);

	if ($sector=='CONUS') $ourSectorType = $sectorTypes[1];
	else if ($sector=='wus'||$sector=='ak') $ourSectorType = $sectorTypes[2];
	else if ($sector=='tpw') $ourSectorType = $sectorTypes[3];
	else $ourSectorType = $sectorTypes[0];

	$gifWidth = $satBandSectors[$ourSectorType]['width'];
	$imageWidth = $satBandSectors[$ourSectorType]['width'];
	$imageHeight = $satBandSectors[$ourSectorType]['height'];

?>
<!--
https://cdn.star.nesdis.noaa.gov/GOES17/GLM/SECTOR/wus/EXTENT3/GOES17-WUS-EXTENT3-1000x1000.gif
https://cdn.star.nesdis.noaa.gov/GOES17/ABI/CONUS/GEOCOLOR/GOES17-CONUS-GEOCOLOR-625x375.gif
-->
	<img src="https://cdn.star.nesdis.noaa.gov/GOES17/<?php echo $nesdisDirectory.($sector=='CONUS'?'/':'/SECTOR/')?><?php echo $sector?>/<?php echo $satBand?>/GOES17-<?php echo strtoupper($sector)?>-<?php echo $satBand?>-<?php echo $imageWidth?>x<?php echo $imageHeight?>.gif" alt="<?php echo $sector?> GIF Animation" height="<?php echo (($imageWidth>625)&&(((!$standAlone&&!$wideScreen)||!$displayWide)))?$imageHeight*$ratio:$imageHeight?>" width="<?php echo (($imageWidth>625)&&(((!$standAlone&&!$wideScreen)||!$displayWide)))?$imageWidth*$ratio:$imageWidth?>"/>

</div>
<div align="center">
<?php if ($sector=='CONUS'||$sector=='FD'||$sector=='ak'||$sector=='hi'||$sector=='np'||$sector=='pnw'||$sector=='psw'||$sector=='tpw'||$sector=='wus') {
	echo '<div style="font-size:12px" align="center">';
		if($sector=='CONUS') {
			echo 'Latest <a href="https://cdn.star.nesdis.noaa.gov/GOES17/'.$nesdisDirectory.'/'.$sector.'/GEOCOLOR/2500x1500.jpg" target="_blank">2500x1500</a> Pixel Image';
		} else if ($sector=='FD') {
			echo 'Latest <a href="https://cdn.star.nesdis.noaa.gov/GOES17/'.$nesdisDirectory.'/FD/'.$satBand.'/5424x5424.jpg" target="_blank">5424x5424 (16+MB)</a> Pixel Image';
		} else if ($sector=='np'||$sector=='tpw') {
			echo 'Latest <a href="https://cdn.star.nesdis.noaa.gov/GOES17/'.$nesdisDirectory.'/SECTOR/'.$sector.'/'.$satBand.'/3600x2160.jpg" target="_blank">3600x2160</a> or <a href="https://cdn.star.nesdis.noaa.gov/GOES17/'.$nesdisDirectory.'/SECTOR/'.$sector.'/'.$satBand.'/latest.jpg" target=_blank">7200x4340 (26+MB!)</a> Pixel Image';
		} else if ($sector=='ak'||$sector=='wus') {
			echo 'Latest <a href="https://cdn.star.nesdis.noaa.gov/GOES17/'.$nesdisDirectory.'/SECTOR/'.$sector.'/'.$satBand.'/2000x2000.jpg" target="_blank">2000x2000</a> or <a href="https://cdn.star.nesdis.noaa.gov/GOES17/'.$nesdisDirectory.'/SECTOR/'.$sector.'/'.$satBand.'/latest.jpg" target="_blank">4000x4000</a> Pixel Image';
		} else if ($sector=='hi'||$sector=='pnw'||$sector=='psw') {
			echo 'Latest <a href="https://cdn.star.nesdis.noaa.gov/GOES17/'.$nesdisDirectory.'/SECTOR/'.$sector.'/'.$satBand.'/latest.jpg" target="_blank">2400x2400</a> Pixel Image';
//		}
	}	echo '</div>';
}
if ($doDebug) {
	echo '$imageWidth: '.$imageWidth.', $imageHeight: '.$imageHeight.', $wideScreen: '.($wideScreen?'true':'false').'<br/>';
}
?>
	<?php { // Adds New UTC Timer Display
		echo '<span style="line-height:140%">The date is currently <b>'.gmdate("M j, Y").'</b>. The time is <b>';
		echo('<span id="zTimer">'.gmdate("Hi").'</span> Zulu');
		if ($useUTC) echo (', <span id="gmTimer">'.gmdate("H:i:s").'</span> UTC');
		echo '.</b></span><br/>';
	}
	if (!$standAlone&&!$wideScreen) {
	echo (file_exists('wxGOES17-GIFLoops-SA.php'))?'<span style="font-size:14px; align:center"><br/><a href="http://'.$_SERVER['SERVER_NAME'].'/wxGOES17-GIFLoops-SA.php" target="_blank" title="New Tab">Larger Image Loop</a></span><br/>':'';
}?><div style="font-size:10px; color: black; text-align:center">
  <span style="font-size:9px; text-align:center">The above animated images are produced by <a href="https://www.star.nesdis.noaa.gov/GOES/sectors_index.php" target="_blank" title="Off Site">NOAA GOES Satellite Distribution Center</a><br/>Script by <a href="https://gwwilkins.org" target="_blank" title="New Tab">SELincoln Weather</a> - Image Resizing Code by <a href="https://somdweather.com/" target="_blank" title="New Tab">Southern Maryland Weather</a><br/>
</span>
<?php  if ($doDebug) {
	$debugText .= '$imageWidth: '.$imageWidth.', $imageHeight: '.$imageHeight.', $standAlone: '.($standAlone==true?'true':'false').'<br/>'; 
} ?>
</div>
</div>
<?php if ($doDebug) print '<br/>'.$debugText;?>
</div> <!-- End #selectors id -->
<script type="text/javascript">
function zuluTimer() {<!--
//<![CDATA[
  var d = new Date();
  var _min = d.getMinutes();
	var _hour = d.getUTCHours();
	var _sec = d.getSeconds();
if ( ( ((_hour+1)/3)== Math.round((_hour+1)/3) )&&(!(_min%60)&&!(_sec%60))) {
  console.log("((_hour+1)/3): "+((_hour+1)/3));
	console.log("Math.round((_hour+1)/3): "+Math.round((_hour+1)/3));
}
  var count = (60 - _sec); // current count
  var counter=setInterval(timer, 1000);
  function timer() {
    count=count-1;
    if (count <= 0) {
      clearInterval(counter);
      zuluTimer();
    }
  } 
	<?php echo 'document.getElementById("zTimer").innerHTML = ((_hour<10)?(\'0\'+_hour):_hour).toString() + ((_min<10)?(\'0\'+_min):_min).toString();';?>
} zuluTimer();
//]]>
-->
function gmtTimer() {<!--
//<![CDATA[
  var d = new Date();
  var _min = d.getMinutes();
	var _hour = d.getUTCHours();
	var _sec = d.getSeconds();
if ( ( ((_hour+1)/3)== Math.round((_hour+1)/3) )&&(!(_min%60)&&!(_sec%60))) {
  console.log("((_hour+1)/3): "+((_hour+1)/3));
	console.log("Math.round((_hour+1)/3): "+Math.round((_hour+1)/3));
}
  var count = (60 - _sec); // current count
  var counter=setInterval(timer, 1000);
  function timer() {
    count=count-1;
		<?php echo 'document.getElementById("gmTimer").innerHTML = ((_hour<10)?(\'0\'+_hour):_hour).toString() +encodeURI(":") + ((_min<10)?(\'0\'+_min):_min).toString() + encodeURI(":") + ((_sec<10)?(\'0\'+_sec):_sec).toString();';?>
		_sec = _sec + 1;
		if (count <= 0) {
      clearInterval(counter);
      gmtTimer();
    }
	}
} gmtTimer();
//]]>
-->
</script>
